module SymbolicMaxPlus where

import SMT
import SymbolicPolynomial

-- max {p1, ..., pn}
type SymbolicMaxPlus = [SymbolicPolynomial]

var :: String -> SymbolicMaxPlus
var x = [SymbolicPolynomial.var x]

const :: Exp -> SymbolicMaxPlus
const e = [SymbolicPolynomial.const e]

flatten :: [SymbolicMaxPlus] -> SymbolicMaxPlus
flatten = concat

addConstant :: Exp -> SymbolicMaxPlus -> SymbolicMaxPlus
addConstant c ps = [ SymbolicPolynomial.addConstant c p | p <- ps ]

mult :: Formula -> SymbolicMaxPlus -> SymbolicMaxPlus
mult f ps = [ SymbolicPolynomial.mult f p | p <- ps ]

-- max P >= max Q
encodeGeq :: SymbolicMaxPlus -> SymbolicMaxPlus -> Formula
encodeGeq ps qs =
  conj [ disj [ SymbolicPolynomial.encodeGeq p q | p <- ps ] | q <- qs ]

-- max P > max Q
encodeGt :: SymbolicMaxPlus -> SymbolicMaxPlus -> Formula
encodeGt ps qs =
  conj [ disj [ SymbolicPolynomial.encodeGt p q | p <- ps ] | q <- qs ]
